Bug 998483 (granite)

Summary: Review Request: granite - GTK extensions for elementary applications
Product: [Fedora] Fedora Reporter: Patrick Griffis <tingping>
Component: Package ReviewAssignee: Christopher Meng <i>
Status: CLOSED DUPLICATE QA Contact: Fedora Extras Quality Assurance <extras-qa>
Severity: unspecified Docs Contact:
Priority: unspecified    
Version: rawhideCC: gotwig, i, kkostas_2006, mildred-bug.redhat, whearn
Target Milestone: ---Flags: i: fedora‑review?
Target Release: ---   
Hardware: Unspecified   
OS: Unspecified   
Whiteboard:
Fixed In Version: Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2014-06-01 19:28:42 EDT Type: Bug
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Attachments:
Description Flags
Build log. none

Description Patrick Griffis 2013-08-19 08:30:52 EDT
Spec URL: http://fpaste.org/33092/69145011/

SRPM URL: http://db.tt/3mTj9AyJ

Description: Granite is an extension of GTK. Among other things, it provides the commonly-used widgets such as mode-switchers, welcome screens, AppMenus, search bars, and more found in elementary apps.

Koji: http://koji.fedoraproject.org/koji/taskinfo?taskID=5828946

rpmlint specfile: 0 packages and 1 specfiles checked; 0 errors, 0 warnings.

rpmlint package: (Neither of these exist)
    granite-devel.x86_64: W: no-documentation
    granite-devel.x86_64: W: no-manual-page-for-binary granite-demo
    2 packages and 0 specfiles checked; 0 errors, 2 warnings.

This pacakge is required for many packages from elementaryOS[1].
Fedora has a feature page[2] for packaging its DE and some of its applications and they would depend on this.

[1] http://elementaryos.org/
[2] https://fedoraproject.org/wiki/Features/pantheon
Comment 1 Christopher Meng 2013-08-19 08:36:04 EDT
Yes, it's in my plan as I want to help get this DE into Fedora, too.
Comment 2 Christopher Meng 2013-08-19 08:37:41 EDT
1. Leave a blank line:

 
%package devel
Summary: Development files for %{name}
Group: Development/Libraries
Requires: %{name}%{?_isa} = %{version}-%{release}
%description devel
This package contains the development files for %{name}.

to

 
%package devel
Summary: Development files for %{name}
Group: Development/Libraries
Requires: %{name}%{?_isa} = %{version}-%{release}

%description devel
This package contains the development files for %{name}.



2. 

%files devel
%dir %{_includedir}/granite/
%{_includedir}/granite/granite.h
%{_includedir}/granite/widgets-utils.h

to

%files devel
%{_includedir}/%{name}/


3.

Source0:        https://launchpad.net/granite/0.2/0.2.2/+download/granite-%{version}.tar.gz

to

Source0:        https://launchpad.net/granite/0.2/%{version}/+download/granite-%{version}.tar.gz
Comment 3 Patrick Griffis 2013-08-20 04:06:40 EDT
updated

SPEC: http://fpaste.org/33352/37698597/

SRPM: http://db.tt/RHdclW3N
Comment 4 Christopher Meng 2013-09-04 21:14:51 EDT
Created attachment 793925 [details]
Build log.

Build failed.

See attachment.
Comment 5 Mildred 2013-12-12 04:39:39 EST
Error:

/lib/libatk-bridge-2.0.so.0: undefined reference to `atk_text_get_string_at_offset'
collect2: error: ld returned 1 exit status

linking of temporary binary failed: Command '['libtool', '--mode=link', '--tag=CC', 'gcc', '-o', '/builddir/build/BUILD/granite-0.2.2/lib/tmp-introspectUumWj2/Granite-1.0', '-export-dynamic', '-O2', '-g', '-pipe', '-Wall', '-Wp,-D_FORTIFY_SOURCE=2', '-fexceptions', '-fstack-protector-strong', '--param=ssp-buffer-size=4', '-grecord-gcc-switches', '-m32', '-march=i686', '-mtune=atom', '-fasynchronous-unwind-tables', '-Wl,-z,relro', '/builddir/build/BUILD/granite-0.2.2/lib/tmp-introspectUumWj2/Granite-1.0.o', '-L.', '-lgranite', '-L/builddir/build/BUILD/granite-0.2.2/lib', '-rpath', '/builddir/build/BUILD/granite-0.2.2/lib', '-lgio-2.0', '-lgobject-2.0', '-Wl,--export-dynamic', '-lgmodule-2.0', '-pthread', '-lglib-2.0']' returned non-zero exit status 1

This symbol seems implemented in atk in the following commit:

https://git.gnome.org/browse/atk/commit/?id=3261a8a792f6688b5575512b8828eea262164713

Which is part of atk version 2.9.4 and 2.10.0 (gnome 3.10). Version 2.10.0 is available on Fedora 20.

If you try to rebuild on Fedora 20, it should probably work.
Comment 6 Christopher Meng 2013-12-12 05:30:58 EST
(In reply to Mildred from comment #5)
> This symbol seems implemented in atk in the following commit:
> 
> https://git.gnome.org/browse/atk/commit/
> ?id=3261a8a792f6688b5575512b8828eea262164713
> 
> Which is part of atk version 2.9.4 and 2.10.0 (gnome 3.10). Version 2.10.0
> is available on Fedora 20.
> 
> If you try to rebuild on Fedora 20, it should probably work.

I will scratch a build again on Rawhide later.
Comment 7 Christopher Meng 2013-12-12 08:36:11 EST
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated


Issues:
=======
- Package does not contain duplicates in %files.
  Note: warning: File listed twice: /usr/include/granite
  See: http://fedoraproject.org/wiki/Packaging/Guidelines#DuplicateFiles

----> Please use %{_includedir}/%{name}/ only.

===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Header files in -devel subpackage, if present.
[x]: ldconfig called in %post and %postun if required.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.
[x]: Development (unversioned) .so files in -devel subpackage, if present.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "LGPL (v3 or later)", "LGPL (v2 or later) (with incorrect FSF address)",
     "Unknown or generated". 2 files have unknown license. Detailed output of
     licensecheck:


LGPL (v2 or later) (with incorrect FSF address)
-----------------------------------------------
/var/lib/mock/fedora-rawhide-i386/root/builddir/build/BUILD/granite-0.2.2/lib/Widgets/widgets-utils.c

LGPL (v3 or later)
------------------
/var/lib/mock/fedora-rawhide-i386/root/builddir/build/BUILD/granite-0.2.2/demo/main.vala
/var/lib/mock/fedora-rawhide-i386/root/builddir/build/BUILD/granite-0.2.2/lib/Application.vala
/var/lib/mock/fedora-rawhide-i386/root/builddir/build/BUILD/granite-0.2.2/lib/Drawing/BufferSurface.vala
/var/lib/mock/fedora-rawhide-i386/root/builddir/build/BUILD/granite-0.2.2/lib/Drawing/Color.vala
/var/lib/mock/fedora-rawhide-i386/root/builddir/build/BUILD/granite-0.2.2/lib/Drawing/Utilities.vala
/var/lib/mock/fedora-rawhide-i386/root/builddir/build/BUILD/granite-0.2.2/lib/GtkPatch/AboutDialog.vala
/var/lib/mock/fedora-rawhide-i386/root/builddir/build/BUILD/granite-0.2.2/lib/Services/Contractor.vala
/var/lib/mock/fedora-rawhide-i386/root/builddir/build/BUILD/granite-0.2.2/lib/Services/ContractorProxy.vala
/var/lib/mock/fedora-rawhide-i386/root/builddir/build/BUILD/granite-0.2.2/lib/Services/IconFactory.vala
/var/lib/mock/fedora-rawhide-i386/root/builddir/build/BUILD/granite-0.2.2/lib/Services/Logger.vala
/var/lib/mock/fedora-rawhide-i386/root/builddir/build/BUILD/granite-0.2.2/lib/Services/Paths.vala
/var/lib/mock/fedora-rawhide-i386/root/builddir/build/BUILD/granite-0.2.2/lib/Services/Settings.vala
/var/lib/mock/fedora-rawhide-i386/root/builddir/build/BUILD/granite-0.2.2/lib/Services/SimpleCommand.vala
/var/lib/mock/fedora-rawhide-i386/root/builddir/build/BUILD/granite-0.2.2/lib/Services/System.vala
/var/lib/mock/fedora-rawhide-i386/root/builddir/build/BUILD/granite-0.2.2/lib/Widgets/AboutDialog.vala
/var/lib/mock/fedora-rawhide-i386/root/builddir/build/BUILD/granite-0.2.2/lib/Widgets/AppMenu.vala
/var/lib/mock/fedora-rawhide-i386/root/builddir/build/BUILD/granite-0.2.2/lib/Widgets/CellRendererBadge.vala
/var/lib/mock/fedora-rawhide-i386/root/builddir/build/BUILD/granite-0.2.2/lib/Widgets/CellRendererExpander.vala
/var/lib/mock/fedora-rawhide-i386/root/builddir/build/BUILD/granite-0.2.2/lib/Widgets/CollapsiblePaned.vala
/var/lib/mock/fedora-rawhide-i386/root/builddir/build/BUILD/granite-0.2.2/lib/Widgets/CompositedWindow.vala
/var/lib/mock/fedora-rawhide-i386/root/builddir/build/BUILD/granite-0.2.2/lib/Widgets/ContractorMenu.vala
/var/lib/mock/fedora-rawhide-i386/root/builddir/build/BUILD/granite-0.2.2/lib/Widgets/ContractorView.vala
/var/lib/mock/fedora-rawhide-i386/root/builddir/build/BUILD/granite-0.2.2/lib/Widgets/DatePicker.vala
/var/lib/mock/fedora-rawhide-i386/root/builddir/build/BUILD/granite-0.2.2/lib/Widgets/DecoratedWindow.vala
/var/lib/mock/fedora-rawhide-i386/root/builddir/build/BUILD/granite-0.2.2/lib/Widgets/DynamicNotebook.vala
/var/lib/mock/fedora-rawhide-i386/root/builddir/build/BUILD/granite-0.2.2/lib/Widgets/Entries.vala
/var/lib/mock/fedora-rawhide-i386/root/builddir/build/BUILD/granite-0.2.2/lib/Widgets/LightWindow.vala
/var/lib/mock/fedora-rawhide-i386/root/builddir/build/BUILD/granite-0.2.2/lib/Widgets/ModeButton.vala
/var/lib/mock/fedora-rawhide-i386/root/builddir/build/BUILD/granite-0.2.2/lib/Widgets/PopOver.vala
/var/lib/mock/fedora-rawhide-i386/root/builddir/build/BUILD/granite-0.2.2/lib/Widgets/SidebarPaned.vala
/var/lib/mock/fedora-rawhide-i386/root/builddir/build/BUILD/granite-0.2.2/lib/Widgets/SourceList.vala
/var/lib/mock/fedora-rawhide-i386/root/builddir/build/BUILD/granite-0.2.2/lib/Widgets/StaticNotebook.vala
/var/lib/mock/fedora-rawhide-i386/root/builddir/build/BUILD/granite-0.2.2/lib/Widgets/StatusBar.vala
/var/lib/mock/fedora-rawhide-i386/root/builddir/build/BUILD/granite-0.2.2/lib/Widgets/ThinPaned.vala
/var/lib/mock/fedora-rawhide-i386/root/builddir/build/BUILD/granite-0.2.2/lib/Widgets/TimePicker.vala
/var/lib/mock/fedora-rawhide-i386/root/builddir/build/BUILD/granite-0.2.2/lib/Widgets/ToolButtonWithMenu.vala
/var/lib/mock/fedora-rawhide-i386/root/builddir/build/BUILD/granite-0.2.2/lib/Widgets/Utils.vala
/var/lib/mock/fedora-rawhide-i386/root/builddir/build/BUILD/granite-0.2.2/lib/Widgets/Welcome.vala
/var/lib/mock/fedora-rawhide-i386/root/builddir/build/BUILD/granite-0.2.2/lib/Widgets/WrapLabel.vala
/var/lib/mock/fedora-rawhide-i386/root/builddir/build/BUILD/granite-0.2.2/lib/style-classes.vala

Unknown or generated
--------------------
/var/lib/mock/fedora-rawhide-i386/root/builddir/build/BUILD/granite-0.2.2/lib/Widgets/close-button.c
/var/lib/mock/fedora-rawhide-i386/root/builddir/build/BUILD/granite-0.2.2/lib/Widgets/widgets-utils.h


[x]: License file installed when any subpackage combination is installed.
[?]: Package requires other packages for directories it uses.
     Note: No known owner of /usr/share/locale/rue,
     /usr/share/locale/rue/LC_MESSAGES
[?]: Package must own all directories that it creates.
     Note: Directories without known owners:
     /usr/share/locale/rue/LC_MESSAGES, /usr/share/locale/rue

----> Hmm? Suspicious.

[!]: Package does not own files or directories owned by other packages.
     Note: Dirs in package are owned also by:
     /usr/share/icons/hicolor/24x24/actions(hicolor-icon-theme),
     /usr/share/icons/hicolor/22x22/actions(hicolor-icon-theme),
     /usr/share/icons/hicolor/scalable/actions(hicolor-icon-theme),
     /usr/share/icons/hicolor/16x16/actions(hicolor-icon-theme),
     /usr/share/icons/hicolor/24x24(anaconda-core, hicolor-icon-theme, fedora-
     logos), /usr/share/icons/hicolor/16x16(anaconda-core, hicolor-icon-theme,
     fedora-logos), /usr/share/icons/hicolor/48x48/actions(hicolor-icon-
     theme), /usr/share/icons/hicolor/48x48(anaconda-core, hicolor-icon-theme,
     fedora-logos, hexchat), /usr/share/icons/hicolor/scalable(hicolor-icon-
     theme, fedora-logos, hexchat), /usr/share/icons/hicolor/22x22(anaconda-
     core, hicolor-icon-theme, fedora-logos), /usr/share/icons/hicolor/32x32
     (anaconda-core, hicolor-icon-theme, fedora-logos),
     /usr/share/icons/hicolor(hicolor-icon-theme, fedora-logos),
     /usr/share/icons/hicolor/32x32/actions(hicolor-icon-theme)

Please add "Requires: hicolor-icon-theme"

[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: The spec file handles locales properly.
[x]: Package consistently uses macros (instead of hard-coded directory names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[x]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: gtk-update-icon-cache is invoked in %postun and %posttrans if package
     contains icons.
     Note: icons in granite
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 20480 bytes in 3 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Each %files section contains %defattr if rpm < 4.4
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Fully versioned dependency in subpackages if applicable.
[x]: Uses parallel make %{?_smp_mflags} macro.
[x]: The placement of pkgconfig(.pc) files are correct.
[x]: SourceX tarball generation or download is documented.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.


Rpmlint
-------
Checking: granite-0.2.2-2.fc21.i686.rpm
          granite-devel-0.2.2-2.fc21.i686.rpm
          granite-0.2.2-2.fc21.src.rpm
granite-devel.i686: W: no-documentation
granite-devel.i686: W: no-manual-page-for-binary granite-demo
3 packages and 0 specfiles checked; 0 errors, 2 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint granite granite-devel
granite.i686: W: unused-direct-shlib-dependency /usr/lib/libgranite.so.1.0.1 /lib/libpangocairo-1.0.so.0
granite.i686: W: unused-direct-shlib-dependency /usr/lib/libgranite.so.1.0.1 /lib/libatk-1.0.so.0
granite.i686: W: unused-direct-shlib-dependency /usr/lib/libgranite.so.1.0.1 /lib/libcairo-gobject.so.2
granite.i686: W: unused-direct-shlib-dependency /usr/lib/libgranite.so.1.0.1 /lib/libgthread-2.0.so.0
granite-devel.i686: W: no-documentation
granite-devel.i686: W: no-manual-page-for-binary granite-demo
2 packages and 0 specfiles checked; 0 errors, 6 warnings.
# echo 'rpmlint-done:'



Requires
--------
granite (rpmlib, GLIBC filtered):
    /bin/sh
    libatk-1.0.so.0
    libc.so.6
    libcairo-gobject.so.2
    libcairo.so.2
    libgdk-3.so.0
    libgdk_pixbuf-2.0.so.0
    libgee.so.2
    libgio-2.0.so.0
    libglib-2.0.so.0
    libgobject-2.0.so.0
    libgthread-2.0.so.0
    libgtk-3.so.0
    libm.so.6
    libpango-1.0.so.0
    libpangocairo-1.0.so.0
    rtld(GNU_HASH)

granite-devel (rpmlib, GLIBC filtered):
    /usr/bin/pkg-config
    granite(x86-32)
    libatk-1.0.so.0
    libc.so.6
    libcairo-gobject.so.2
    libcairo.so.2
    libgdk-3.so.0
    libgdk_pixbuf-2.0.so.0
    libgee.so.2
    libgio-2.0.so.0
    libglib-2.0.so.0
    libgobject-2.0.so.0
    libgranite.so.1
    libgthread-2.0.so.0
    libgtk-3.so.0
    libm.so.6
    libpango-1.0.so.0
    libpangocairo-1.0.so.0
    pkgconfig(cairo)
    pkgconfig(gdk-3.0)
    pkgconfig(gdk-pixbuf-2.0)
    pkgconfig(gee-1.0)
    pkgconfig(gio-unix-2.0)
    pkgconfig(glib-2.0)
    pkgconfig(gobject-2.0)
    pkgconfig(gthread-2.0)
    pkgconfig(gtk+-3.0)
    rtld(GNU_HASH)



Provides
--------
granite:
    granite
    granite(x86-32)
    libgranite.so.1

granite-devel:
    granite-devel
    granite-devel(x86-32)
    pkgconfig(granite)



Source checksums
----------------
https://launchpad.net/granite/0.2/0.2.2/+download/granite-0.2.2.tar.gz :
  CHECKSUM(SHA256) this package     : 341f94cd8c2af60fc072fb8602e1406bccd77189aad76424b172c3ce08c173cc
  CHECKSUM(SHA256) upstream package : 341f94cd8c2af60fc072fb8602e1406bccd77189aad76424b172c3ce08c173cc


Generated by fedora-review 0.5.0 (920221d) last change: 2013-08-30
Command line :/usr/bin/fedora-review -rvn granite-0.2.2-2.fc19.src.rpm
Buildroot used: fedora-rawhide-i386
Active plugins: Generic, Shell-api, C/C++
Disabled plugins: Java, Python, SugarActivity, Perl, R, PHP, Ruby
Disabled flags: EPEL5, EXARCH, DISTTAG
Comment 8 Wesley Hearn 2014-02-17 15:14:43 EST
I talked to TingPing on IRC and I will be taking over the packaging efforts for granite.

SPEC: http://jknife.fedorapeople.org/review/granite/granite.spec
SRPM: http://jknife.fedorapeople.org/review/granite/granite-0.2.3-1.fc20.src.rpm
Comment 9 Wesley Hearn 2014-02-17 15:56:08 EST
As for the missing man page, I have created a bug report here: https://bugs.launchpad.net/granite/+bug/1281294

For the unused-direct-shlib-dependency I am trying to track down exactly what is causing it.
Comment 10 Christopher Meng 2014-02-18 19:51:36 EST
OK.

I will review it later.
Comment 11 Christopher Meng 2014-03-29 23:40:11 EDT
0.2.3.1 is out. I will review this once you update the package.

I hope you can create a new bug and mark this as duplicate of the one you create.

Thanks.
Comment 12 Eduard Gotwig 2014-04-20 18:01:26 EDT
Hello,

any progress on this package review?

I would like to be able to use Granite for software projects, and offer fedora packages :)
Comment 13 Wesley Hearn 2014-06-01 19:28:42 EDT

*** This bug has been marked as a duplicate of bug 1103545 ***